"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var core_2 = require("@angular/core");
exports.ContentChild = core_2.ContentChild;
exports.Type = core_2.Type;
exports.forwardRef = core_2.forwardRef;
var currentTemplateElement;
var firstVal = {};
/** Internal Helpers */
var Utils = (function () {
    function Utils() {
    }
    Utils.IterateAndGetChanges = function (obj) {
        if (ej.isNullOrUndefined(obj.tags) || obj.tags.length === 0) {
            return null;
        }
        var res = {};
        for (var i = 0, tags = obj.tags; i < tags.length; i++) {
            var tag = tags[i], tagElement = obj['_' + tag.replace(/\./g, '_')];
            if (!ej.isNullOrUndefined(tagElement) && tagElement.hasChanges) {
                res[tag] = tagElement.getChangesAndReset();
            }
        }
        return res;
    };
    Utils.AngularizeInputs = function (inputs, twoways) {
        for (var i = 0, len = inputs.length; i < len; i++) {
            var element = inputs[i];
            inputs[i] = element.replace(/\./g, '_') + ':' + element;
        }
        for (var i = 0; i < twoways.length; i++) {
            var element = twoways[i];
            element = element.replace(/\./g, '_') + '_two:' + element;
            inputs.push(element);
        }
        return inputs;
    };
    return Utils;
}());
exports.Utils = Utils;
var EJComponents = (function () {
    function EJComponents(controlName, el, cdRef) {
        this.controlName = controlName;
        this.el = el;
        this.cdRef = cdRef;
        this.model = {};
        //        this.__shadow = this.dom.getShadowRoot(this.el.nativeElement);
        this.firstCheck = true;
        this.createEvents(this.outputs);
        this.createTwoways(this.twoways);
    }
    EJComponents.prototype.createEvents = function (events) {
        var model = this.model, self = this;
        if (events && events.length) {
            for (var i = 0; i < events.length; i++) {
                var event_1 = events[i];
                if (event_1.startsWith('model.')) {
                    continue;
                }
                self[event_1] = new core_1.EventEmitter(false);
            }
        }
        var complex = this.complexProperties;
        if (complex && complex.length) {
            for (var i = 0; i < complex.length; i++) {
                var element = complex[i];
                ej.createObject(element, {}, model);
            }
        }
    };
    EJComponents.prototype.createTwoways = function (twoways) {
        if (!twoways) {
            return;
        }
        var model = this.model;
        for (var i = 0; i < twoways.length; i++) {
            var element = twoways[i];
            if (element.indexOf(':') !== -1) {
                element = element.replace(/:.+/g, '');
            }
            ej.createObject(element + 'Change', new core_1.EventEmitter(), model);
            ej.createObject(element, this.addTwoways(element), model);
        }
    };
    EJComponents.prototype.addTwoways = function (prop) {
        var model = this.model, value = firstVal; // , originalProp = prop.replace(/-/g, '.');
        return function (newVal, isApp) {
            if (value === firstVal) {
                value = ej.getObject(prop + '_two', model);
                if (value === undefined) {
                    value = ej.getObject(prop, this === undefined || this.defaults === undefined ? {} : this.defaults);
                }
            }
            if (newVal === undefined) {
                return value;
            }
            if (value === newVal) {
                return;
            }
            value = newVal;
            if (!isApp) {
                ej.createObject(prop + '_two', newVal, model);
                ej.getObject(prop + 'Change', model).emit(newVal);
            }
        };
    };
    EJComponents.prototype.ngAfterContentInit = function () {
        this.firstCheck = false;
        for (var i = 0; i < this.tags.length; i++) {
            var element = this.tags[i], item = this['_' + element.replace(/\./g, '_')];
            if (!ej.isNullOrUndefined(item)) {
                ej.createObject(element, item.getList(), this.model);
            }
        }
        var model = this.model, events = this.outputs;
        if (events) {
            for (var i = 0; i < events.length; i++) {
                var event_2 = events[i];
                EJComponents.bindAndRaiseEvent(this, model, event_2);
            }
        }
        for (var i = 0; i < this.inputs.length; i++) {
            var property = this.inputs[i].split(':');
            if (this[property[0]] != null) {
                if (property[0].indexOf('_') == -1) {
                    this.model[property[1]] = this[property[1]];
                }
                else if (property[0].indexOf('_two') == -1) {
                    var tempObj = {};
                    var key = property[0].replace(/\_/g, '.');
                    ej.createObject(key, this[property[0]], tempObj);
                    var rootProp = key.split('.')[0];
                    $.extend(true, this.model[rootProp], tempObj[rootProp]);
                }
            }
        }
        for (var i = 0; i < this.twoways.length; i++) {
            var twoway = this.twoways[i];
            var twowayProperty = twoway.replace(/\./g, '_') + '_two';
            if (this[twowayProperty] != null) {
                if (twoway.indexOf('.') == -1) {
                    this.model[twowayProperty] = this[twowayProperty];
                }
                else {
                    var tempObj = {};
                    var key = twoway + '_two';
                    ej.createObject(key, this[twowayProperty], tempObj);
                    var rootProp = twowayProperty.split('_')[0];
                    $.extend(true, this.model[rootProp], tempObj[rootProp]);
                }
            }
        }
        var nativeElement = this.isEditor ? $(this.el.nativeElement.children) : $(this.el.nativeElement);
        this.widget = $(nativeElement)['ej' + this.controlName](this.model)['ej' + this.controlName]('instance');
    };
    EJComponents.bindAndRaiseEvent = function (instance, model, event) {
        if (!event.startsWith('model.')) {
            model[event] = function (params) {
                instance[event]['emit'](params);
            };
        }
    };
    EJComponents.prototype.ngOnChanges = function (changes) {
        if (this.firstCheck) {
            return;
        }
        var ngChanges = {};
        for (var key in changes) {
            var element = changes[key];
            if (element.previousValue === element.currentValue) {
                break;
            }
            key = key.replace(/\_/g, '.');
            if (key.endsWith('.two')) {
                var oKey = key.replace('.two', ''), valFn = ej.getObject(oKey, this.widget['model']);
                valFn(element.currentValue, true);
                ej.createObject(oKey, valFn, ngChanges);
            }
            ej.createObject(key, element.currentValue, ngChanges);
        }
        this.widget['setModel'](ngChanges, $.isPlainObject(ngChanges));
    };
    EJComponents.prototype.ngAfterContentChecked = function () {
        /// TODO: ChangeDetection Third/Multi level
        var changes = Utils.IterateAndGetChanges(this);
        for (var key in changes) {
            if (changes.hasOwnProperty(key)) {
                var element = changes[key];
                this.widget['_' + key](element);
            }
        }
    };
    EJComponents.prototype.ngOnDestroy = function () {
        this.widget['destroy']();
    };
    return EJComponents;
}());
exports.EJComponents = EJComponents;
var ComplexTagElement = (function () {
    function ComplexTagElement() {
        this.valueChange = new core_1.EventEmitter();
        this.hasChanges = false;
        this.firstChange = true;
        var complexes = this.complexProperties;
        for (var i = 0; complexes !== undefined && i < complexes.length; i++) {
            var element = complexes[i];
            ej.createObject(element, {}, this);
        }
        Object.defineProperty(this, 'parent', {
            enumerable: false,
            writable: true,
            value: null
        });
    }
    ComplexTagElement.prototype.ngOnInit = function () {
        this.firstChange = false;
        for (var i = 0; i < this.inputs.length; i++) {
            var property = this.inputs[i].split(':');
            if (this[property[0]] != null) {
                if (property[0].indexOf('_') != -1) {
                    var tempObj = {};
                    var key = property[0].replace(/\_/g, '.');
                    ej.createObject(key, this[property[0]], tempObj);
                    var rootProp = key.split('.')[0];
                    $.extend(true, this[rootProp], tempObj[rootProp]);
                }
            }
        }
    };
    ComplexTagElement.prototype.ensureCleanObject = function () {
        var tags = this.tags;
        for (var i = 0; i < tags.length; i++) {
            var element = tags[i], tagElement = this['_' + element.replace(/\./g, '_')];
            if (i === 0 && this[element]) {
                return;
            }
            if (ej.isNullOrUndefined(tagElement)) {
                continue;
            }
            ej.createObject(element, tagElement.getList(), this);
        }
    };
    ComplexTagElement.prototype.ngOnChanges = function (changes) {
        if (this.firstChange) {
            return;
        }
        this.recentChanges = changes;
        this.hasChanges = true;
    };
    ComplexTagElement.prototype.getChangesAndReset = function () {
        if (this.hasChanges === false) {
            return;
        }
        var changes = this.recentChanges || {};
        for (var key in changes) {
            var oKey = key;
            if (key.indexOf('_') != -1) {
                oKey = oKey.replace(/\_/g, '.');
                ej.createObject(oKey, changes[key].currentValue, changes);
            }
            else if (changes.hasOwnProperty(key)) {
                changes[oKey] = changes[key].currentValue;
            }
        }
        var contentChanges = Utils.IterateAndGetChanges(this);
        if (!$.isEmptyObject(contentChanges)) {
            for (var key in contentChanges) {
                if (contentChanges.hasOwnProperty(key)) {
                    var element = contentChanges[key];
                    // this.el.nativeElement.
                    this.parent.widget['_' + this.property.replace(/\./g, '_') + '_' + key](element);
                }
            }
        }
        this.hasChanges = false;
        return changes;
    };
    ComplexTagElement.prototype.ngAfterContentChecked = function () {
        var tags = this.tags;
        for (var i = 0, len = tags.length; i < len; i++) {
            var element = tags[i], tagElement = this['_' + element.replace(/\./g, '_')];
            if (tagElement && tagElement.hasChanges) {
                this.hasChanges = true;
            }
        }
    };
    return ComplexTagElement;
}());
exports.ComplexTagElement = ComplexTagElement;
var ArrayTagElement = (function () {
    function ArrayTagElement(propertyName) {
        this.propertyName = propertyName;
        this.hasChanges = false;
    }
    // TODO: Need to consider dynamic child change
    ArrayTagElement.prototype.ngAfterContentInit = function () {
        var _this = this;
        var index = 0;
        this.list = this.children.map(function (child) {
            child.index = index++;
            child.property = _this.propertyName;
            return child;
        });
    };
    ArrayTagElement.prototype.ngOnChanges = function (changes) {
    };
    ArrayTagElement.prototype.getList = function () {
        var list = this.list;
        for (var i = 0; i < list.length; i++) {
            list[i].ensureCleanObject();
        }
        return list;
    };
    ArrayTagElement.prototype.getChangesAndReset = function () {
        this.hasChanges = false;
        return this.recentChanges;
    };
    ArrayTagElement.prototype.ngAfterContentChecked = function () {
        var changes = {}, res = changes[this.propertyName] = [], childChange;
        for (var i = 0, list = this.list; i < list.length; i++) {
            var child = list[i];
            if (child.hasChanges) {
                childChange = child.getChangesAndReset();
                for (var key in childChange) {
                    if (key.indexOf('_') == -1) {
                        $.extend(true, child[key], childChange[key]);
                    }
                }
                if (!ej.isNullOrUndefined(childChange)) {
                    res.push({
                        index: child.index,
                        change: childChange
                    });
                }
            }
        }
        if (res.length > 0) {
            this.recentChanges = res;
            this.hasChanges = true;
        }
    };
    return ArrayTagElement;
}());
exports.ArrayTagElement = ArrayTagElement;
function CreateComplexDirective(args, ejArgs) {
    return core_1.Directive(args).Class({
        extends: ComplexTagElement,
        constructor: [ejArgs.type, function (widget) {
                this.tags = ejArgs.tags;
                this.complexProperties = ejArgs.complexes;
                this.inputs = args.inputs;
                ComplexTagElement.call(this);
                this.parent = widget;
                currentTemplateElement = this;
            }]
    });
}
exports.CreateComplexDirective = CreateComplexDirective;
var EJTemplateDirective = (function () {
    function EJTemplateDirective(el, viewContainerRef, templateRef) {
        this.el = el;
        this.viewContainerRef = viewContainerRef;
        this.templateRef = templateRef;
        this.childViews = [];
        this.element = currentTemplateElement;
    }
    EJTemplateDirective.prototype.ngOnInit = function () {
        var template = this.viewContainerRef.createEmbeddedView(this.templateRef, { '$implicit': [] });
        var templID = ej.getGuid('angulartmplstr');
        var tempEle = ej.buildTag('div#' + templID);
        $(tempEle).append(template.rootNodes);
        ej.createObject('template', $($(tempEle).append(template.rootNodes)).html(), this.element);
        this.element.template = $($(tempEle).append(template.rootNodes)).html();
        ej.createObject('_templateRef', this.templateRef, this.element);
        ej.createObject('_viewRef', this.viewContainerRef, this.element);
        $(tempEle).remove();
    };
    EJTemplateDirective.prototype.ngAfterViewInit = function () {
        var _this = this;
        window.setTimeout(function () {
            _this.compileTempalte();
        });
        var parentWidget = this.element.parent.widget || this.element.widget;
        parentWidget.element.on(parentWidget.pluginName + 'refresh', function () {
            if (parentWidget.angularTemplate) {
                _this.compileTempalte();
            }
        });
    };
    EJTemplateDirective.prototype.compileTempalte = function () {
        var widget = this.element.parent.widget || this.element.widget;
        var element = widget.element;
        var childView;
        var templates = $(element).find('.ej-angular-template');
        var templateObject = widget.angularTemplate;
        for (var template in templateObject) {
            var tmplElement = templates.filter('.' + templateObject[template].key);
            if (tmplElement.length) {
                for (var i = 0; i < tmplElement.length; i++) {
                    childView = templateObject[template].viewRef[i].createEmbeddedView(templateObject[template].templateRef[i], { '$implicit': templateObject[template].itemData[parseInt($(tmplElement[i]).attr('ej-prop'))] });
                    $(tmplElement[i]).empty().append(childView.rootNodes);
                }
            }
            else {
                delete templateObject[template];
            }
        }
    };
    EJTemplateDirective.prototype.clearTempalte = function () {
        var templateObject = this.element.parent.widget.angularTemplate;
        if (templateObject && Object.keys(templateObject).length) {
            for (var tmpl in templateObject) {
                delete templateObject[tmpl];
            }
        }
        for (var childView in this.childViews) {
            delete this.childViews[childView];
        }
        this.viewContainerRef.remove();
    };
    EJTemplateDirective.prototype.ngOnDestroy = function () {
        this.clearTempalte();
    };
    return EJTemplateDirective;
}());
EJTemplateDirective = __decorate([
    core_1.Directive({
        selector: "[e-template]"
    }),
    __metadata("design:paramtypes", [core_1.ElementRef, core_1.ViewContainerRef,
        core_1.TemplateRef])
], EJTemplateDirective);
exports.EJTemplateDirective = EJTemplateDirective;
function CreateArrayTagDirective(property, selector, type) {
    return core_1.Directive({
        selector: selector,
        queries: {
            children: new core_1.ContentChildren(type)
        }
    }).Class({
        extends: ArrayTagElement,
        constructor: function () {
            ArrayTagElement.call(this, property);
        }
    });
}
exports.CreateArrayTagDirective = CreateArrayTagDirective;
function CreateComponent(controlName, componentArgs, ejArgs) {
    componentArgs.changeDetection = core_1.ChangeDetectionStrategy.OnPush;
    var comp = core_1.Component(componentArgs);
    return comp.Class({
        extends: EJComponents,
        constructor: [core_1.ElementRef, core_1.ChangeDetectorRef, function (el, cdRef) {
                this.tags = ejArgs.tags;
                this.outputs = componentArgs.outputs;
                this.inputs = componentArgs.inputs;
                this.twoways = ejArgs.twoways;
                this.isEditor = ejArgs.isEditor;
                this.complexProperties = ejArgs.complexes;
                EJComponents.call(this, controlName, el, cdRef);
            }]
    });
}
exports.CreateComponent = CreateComponent;
function CreateControlValueAccessor(selector, component) {
    var EJDefaultValueAccessor;
    var constAccessor = {
        provide: forms_1.NG_VALUE_ACCESSOR,
        useExisting: core_1.forwardRef(function () { return EJDefaultValueAccessor; }), multi: true
    };
    var valDirective = core_1.Directive({
        selector: selector,
        host: { '(change)': 'onChange($event.value)', '(focusOut)': 'onTouched()' },
        providers: [constAccessor]
    });
    EJDefaultValueAccessor = valDirective.Class({
        constructor: [component, function (host) {
                this.host = host;
            }],
        onChange: function (_) { },
        onTouched: function () { },
        writeValue: function (value) {
            if (this.host.widget) {
                this.host.widget.option('model.value', value);
            }
            else {
                this.host.model.value = value;
            }
        },
        registerOnChange: function (fn) {
            this.onChange = fn;
        },
        registerOnTouched: function (fn) {
            this.onTouched = fn;
        }
    });
    return EJDefaultValueAccessor;
}
exports.CreateControlValueAccessor = CreateControlValueAccessor;
ej.template['text/x-template'] = function (self, selector, data, index, prop) {
    var templateObject = self.angularTemplate;
    if (!templateObject || !templateObject[selector]) {
        templateObject = templateObject || {};
        templateObject[selector] = { key: ej.getGuid('angulartmpl'), itemData: [], viewRef: [], templateRef: [] };
        self.angularTemplate = templateObject;
    }
    var scope = templateObject[selector];
    if (!ej.isNullOrUndefined(index)) {
        if (!scope.itemData) {
            scope.itemData = [];
        }
        scope.itemData[index] = data;
        scope.viewRef[index] = prop._viewRef;
        scope.templateRef[index] = prop._templateRef;
    }
    else {
        scope.itemData = [data];
        scope.viewRef = [prop._viewRef];
        scope.templateRef = [prop._templateRef];
    }
    var actElement = $(selector).html() || '';
    var tempElement = '<div ej-prop=\'' + index + '\' class=\'' + templateObject[selector].key + ' ej-angular-template\'>' + actElement + '</div>';
    return tempElement;
};
ej.template.render = ej.template['text/x-template'];
//# sourceMappingURL=core.js.map