"use strict";
var core_1 = require("./core");
var DiagramCommandManagerCommandInputs = core_1.Utils.AngularizeInputs(['canExecute', 'execute', 'gesture', 'gesture.key', 'gesture.keyModifiers',
    'parameter'], []);
exports.DiagramCommandManagerCommandDirective = core_1.CreateComplexDirective({
    selector: 'e-commandmanager-commands>e-commandmanager-command',
    inputs: DiagramCommandManagerCommandInputs,
    queries: {}
}, {
    tags: [],
    complexes: ['gesture'],
    type: core_1.forwardRef(function () { return exports.DiagramComponent; })
});
exports.DiagramCommandManagerCommandsDirective = core_1.CreateArrayTagDirective('commandManager.commands', 'ej-diagram>e-commandmanager-commands', exports.DiagramCommandManagerCommandDirective);
var DiagramSegmentInputs = core_1.Utils.AngularizeInputs(['direction', 'length', 'point', 'point1', 'point2',
    'type', 'vector1', 'vector2'], []);
exports.DiagramSegmentDirective = core_1.CreateComplexDirective({
    selector: 'e-segments>e-segment',
    inputs: DiagramSegmentInputs,
    queries: {}
}, {
    tags: [],
    complexes: [],
    type: core_1.forwardRef(function () { return exports.DiagramComponent; })
});
exports.DiagramSegmentsDirective = core_1.CreateArrayTagDirective('segments', 'e-connectors>e-segments', exports.DiagramSegmentDirective);
var DiagramConnectorLabelInputs = core_1.Utils.AngularizeInputs(['alignment', 'bold', 'borderColor', 'borderWidth', 'boundaryConstraints',
    'fillColor', 'fontColor', 'fontFamily', 'fontSize', 'horizontalAlignment',
    'hyperlink', 'italic', 'mode', 'name', 'offset',
    'margin', 'margin.right', 'margin.left', 'margin.top', 'margin.bottom',
    'opacity', 'readOnly', 'relativeMode', 'rotateAngle', 'segmentOffset',
    'text', 'textAlign', 'textDecoration', 'verticalAlignment', 'visible',
    'width', 'wrapping'], []);
exports.DiagramConnectorLabelDirective = core_1.CreateComplexDirective({
    selector: 'e-connectorlabels>e-connectorlabel',
    inputs: DiagramConnectorLabelInputs,
    queries: {}
}, {
    tags: [],
    complexes: ['margin'],
    type: core_1.forwardRef(function () { return exports.DiagramComponent; })
});
exports.DiagramConnectorLabelsDirective = core_1.CreateArrayTagDirective('labels', 'e-connectors>e-connectorlabels', exports.DiagramConnectorLabelDirective);
var DiagramConnectorInputs = core_1.Utils.AngularizeInputs(['addInfo', 'bridgeSpace', 'constraints', 'cornerRadius', 'cssClass',
    'horizontalAlign', 'labels', 'lineColor', 'lineDashArray', 'lineHitPadding',
    'lineWidth', 'marginBottom', 'marginLeft', 'marginRight', 'marginTop',
    'name', 'opacity', 'paletteItem', 'parent', 'segments',
    'shape', 'shape.type', 'shape.flow', 'shape.association', 'shape.message',
    'shape.sequence', 'shape.relationship', 'shape.multiplicity', 'shape.multiplicity.type', 'shape.multiplicity.source',
    'shape.multiplicity.source.optional', 'shape.multiplicity.source.lowerBounds', 'shape.multiplicity.source.upperBounds', 'shape.multiplicity.target', 'shape.ActivityFlow',
    'sourceDecorator', 'sourceDecorator.borderColor', 'sourceDecorator.borderWidth', 'sourceDecorator.fillColor', 'sourceDecorator.height',
    'sourceDecorator.pathData', 'sourceDecorator.shape', 'sourceDecorator.width', 'sourceNode', 'sourcePadding',
    'sourcePoint', 'sourcePoint.x', 'sourcePoint.y', 'sourcePort', 'targetDecorator',
    'targetDecorator.borderColor', 'targetDecorator.fillColor', 'targetDecorator.height', 'targetDecorator.pathData', 'targetDecorator.shape',
    'targetDecorator.width', 'targetNode', 'targetPadding', 'targetPoint', 'targetPort',
    'tooltip', 'verticalAlign', 'visible', 'zOrder'], []);
exports.DiagramConnectorDirective = core_1.CreateComplexDirective({
    selector: 'e-connectors>e-connector',
    inputs: DiagramConnectorInputs,
    queries: {
        _segments: new core_1.ContentChild(exports.DiagramSegmentsDirective),
        _labels: new core_1.ContentChild(exports.DiagramConnectorLabelsDirective),
    }
}, {
    tags: ['segments', 'labels'],
    complexes: ['shape', 'shape.multiplicity', 'shape.multiplicity.source', 'sourceDecorator', 'sourcePoint', 'targetDecorator'],
    type: core_1.forwardRef(function () { return exports.DiagramComponent; })
});
exports.DiagramConnectorsDirective = core_1.CreateArrayTagDirective('connectors', 'ej-diagram>e-connectors', exports.DiagramConnectorDirective);
var DiagramNodeLabelInputs = core_1.Utils.AngularizeInputs(['bold', 'borderColor', 'borderWidth', 'fillColor', 'fontColor',
    'fontFamily', 'fontSize', 'horizontalAlignment', 'italic', 'margin',
    'mode', 'name', 'offset', 'opacity', 'overflowType',
    'readOnly', 'rotateAngle', 'text', 'textAlign', 'textDecoration',
    'textOverflow', 'verticalAlignment', 'visible', 'width', 'wrapping'], []);
exports.DiagramNodeLabelDirective = core_1.CreateComplexDirective({
    selector: 'e-nodelabels>e-nodelabel',
    inputs: DiagramNodeLabelInputs,
    queries: {}
}, {
    tags: [],
    complexes: [],
    type: core_1.forwardRef(function () { return exports.DiagramComponent; })
});
exports.DiagramNodeLabelsDirective = core_1.CreateArrayTagDirective('labels', 'e-nodes>e-nodelabels', exports.DiagramNodeLabelDirective);
var DiagramPhaseInputs = core_1.Utils.AngularizeInputs(['label', 'lineColor', 'lineDashArray', 'lineWidth', 'name',
    'offset', 'orientation', 'type'], []);
exports.DiagramPhaseDirective = core_1.CreateComplexDirective({
    selector: 'e-phases>e-phase',
    inputs: DiagramPhaseInputs,
    queries: {}
}, {
    tags: [],
    complexes: [],
    type: core_1.forwardRef(function () { return exports.DiagramComponent; })
});
exports.DiagramPhasesDirective = core_1.CreateArrayTagDirective('phases', 'e-nodes>e-phases', exports.DiagramPhaseDirective);
var DiagramPortInputs = core_1.Utils.AngularizeInputs(['borderColor', 'borderWidth', 'connectorPadding', 'constraints', 'fillColor',
    'name', 'offset', 'pathData', 'shape', 'size',
    'visibility'], []);
exports.DiagramPortDirective = core_1.CreateComplexDirective({
    selector: 'e-ports>e-port',
    inputs: DiagramPortInputs,
    queries: {}
}, {
    tags: [],
    complexes: [],
    type: core_1.forwardRef(function () { return exports.DiagramComponent; })
});
exports.DiagramPortsDirective = core_1.CreateArrayTagDirective('ports', 'e-nodes>e-ports', exports.DiagramPortDirective);
var DiagramNodeInputs = core_1.Utils.AngularizeInputs(['activity', 'addInfo', 'annotation', 'annotation.angle', 'annotation.direction',
    'annotation.height', 'annotation.length', 'annotation.text', 'annotation.width', 'borderColor',
    'borderDashArray', 'borderWidth', 'canUngroup', 'children', 'classifier',
    'class', 'class.name', 'class.attributes', 'class.methods', 'collapseIcon',
    'collapseIcon.borderColor', 'collapseIcon.borderWidth', 'collapseIcon.fillColor', 'collapseIcon.height', 'collapseIcon.horizontalAlignment',
    'collapseIcon.margin', 'collapseIcon.offset', 'collapseIcon.shape', 'collapseIcon.verticalAlignment', 'connectorPadding',
    'constraints', 'container', 'container.orientation', 'container.type', 'cornerRadius',
    'cssClass', 'data', 'data.type', 'data.collection', 'enumeration',
    'enumeration.name', 'enumeration.members', 'event', 'excludeFromLayout', 'expandIcon',
    'expandIcon.borderColor', 'expandIcon.borderWidth', 'expandIcon.fillColor', 'expandIcon.height', 'expandIcon.horizontalAlignment',
    'expandIcon.margin', 'expandIcon.offset', 'expandIcon.shape', 'expandIcon.verticalAlignment', 'fillColor',
    'gateway', 'gradient', 'gradient.LinearGradient', 'gradient.LinearGradient.stops', 'gradient.LinearGradient.x1',
    'gradient.LinearGradient.x2', 'gradient.LinearGradient.y1', 'gradient.LinearGradient.y2', 'gradient.RadialGradient', 'gradient.RadialGradient.cx',
    'gradient.RadialGradient.cy', 'gradient.RadialGradient.fx', 'gradient.RadialGradient.fy', 'gradient.RadialGradient.stops', 'gradient.Stop',
    'gradient.Stop.color', 'gradient.Stop.offset', 'gradient.Stop.opacity', 'group', 'header',
    'height', 'horizontalAlign', 'inEdges', 'interface', 'interface.name',
    'interface.attributes', 'interface.methods', 'isExpanded', 'isSwimlane', 'labels',
    'lanes', 'marginBottom', 'marginLeft', 'marginRight', 'marginTop',
    'maxHeight', 'maxWidth', 'minHeight', 'minWidth', 'name',
    'offsetX', 'offsetY', 'opacity', 'orientation', 'outEdges',
    'paddingBottom', 'paddingLeft', 'paddingRight', 'paddingTop', 'paletteItem',
    'paletteItem.enableScale', 'paletteItem.height', 'paletteItem.margin', 'paletteItem.previewHeight', 'paletteItem.previewWidth',
    'paletteItem.width', 'parent', 'pathData', 'phases', 'phaseSize',
    'pivot', 'points', 'ports', 'rotateAngle', 'shadow',
    'shadow.angle', 'shadow.distance', 'shadow.opacity', 'shape', 'source',
    'subProcess', 'subProcess.adhoc', 'subProcess.boundary', 'subProcess.compensation', 'subProcess.collapsed',
    'subProcess.event', 'subProcess.events', 'subProcess.loop', 'subProcess.Processes', 'subProcess.trigger',
    'subProcess.type', 'task', 'task.call', 'task.compensation', 'task.loop',
    'task.type', 'templateId', 'textBlock', 'tooltip', 'trigger',
    'type', 'verticalAlign', 'visible', 'width', 'zOrder'], []);
exports.DiagramNodeDirective = core_1.CreateComplexDirective({
    selector: 'e-nodes>e-node',
    inputs: DiagramNodeInputs,
    queries: {
        _labels: new core_1.ContentChild(exports.DiagramNodeLabelsDirective),
        _phases: new core_1.ContentChild(exports.DiagramPhasesDirective),
        _ports: new core_1.ContentChild(exports.DiagramPortsDirective),
    }
}, {
    tags: ['labels', 'phases', 'ports'],
    complexes: ['annotation', 'class', 'collapseIcon', 'container', 'data', 'enumeration', 'expandIcon', 'gradient', 'gradient.LinearGradient', 'gradient.RadialGradient', 'gradient.Stop', 'interface', 'paletteItem', 'shadow', 'subProcess', 'task'],
    type: core_1.forwardRef(function () { return exports.DiagramComponent; })
});
exports.DiagramNodesDirective = core_1.CreateArrayTagDirective('nodes', 'ej-diagram>e-nodes', exports.DiagramNodeDirective);
var Outputs = ['autoScrollChange', 'click', 'connectionChange', 'connectorCollectionChange', 'connectorSourceChange',
    'connectorTargetChange', 'contextMenuBeforeOpen', 'contextMenuClick', 'doubleClick', 'drag',
    'dragEnter', 'dragLeave', 'dragOver', 'drop', 'editorFocusChange',
    'groupChange', 'historyChange', 'itemClick', 'mouseEnter', 'mouseLeave',
    'mouseOver', 'nodeCollectionChange', 'propertyChange', 'rotationChange', 'scrollChange',
    'segmentChange', 'selectionChange', 'sizeChange', 'textChange', 'create'
];
var ComplexProperties = ['commandManager', 'contextMenu', 'dataSourceSettings', 'defaultSettings', 'historyManager',
    'layout', 'pageSettings', 'scrollSettings', 'selectedItems', 'snapSettings',
    'tooltip', 'commandManager.commands', 'commandManager.commands.gesture', 'snapSettings.horizontalGridLines', 'snapSettings.verticalGridLines',
    'tooltip.alignment'];
var Inputs = core_1.Utils.AngularizeInputs(['backgroundColor', 'backgroundImage', 'bridgeDirection', 'commandManager', 'connectorTemplate',
    'constraints', 'contextMenu', 'dataSourceSettings', 'defaultSettings', 'drawType',
    'enableAutoScroll', 'enableContextMenu', 'height', 'historyManager', 'labelRenderingMode',
    'layout', 'locale', 'nodeTemplate', 'pageSettings', 'scrollSettings',
    'selectedItems', 'showTooltip', 'snapSettings', 'tool', 'tooltip',
    'width', 'zoomFactor', 'backgroundImage.alignment', 'commandManager.commands', 'commandManager.commands.canExecute',
    'commandManager.commands.execute', 'commandManager.commands.gesture', 'commandManager.commands.parameter', 'contextMenu.showCustomMenuItemsOnly', 'dataSourceSettings.dataSource',
    'dataSourceSettings.id', 'dataSourceSettings.parent', 'dataSourceSettings.query', 'dataSourceSettings.root', 'dataSourceSettings.tableName',
    'defaultSettings.connector', 'defaultSettings.group', 'defaultSettings.node', 'historyManager.canPop', 'historyManager.closeGroupAction',
    'historyManager.pop', 'historyManager.push', 'historyManager.redo', 'historyManager.redoStack', 'historyManager.stackLimit',
    'historyManager.startGroupAction', 'historyManager.undo', 'historyManager.undoStack', 'layout.bounds', 'layout.fixedNode',
    'layout.getLayoutInfo', 'layout.horizontalSpacing', 'layout.margin', 'layout.horizontalAlignment', 'layout.verticalAlignment',
    'layout.orientation', 'layout.type', 'layout.verticalSpacing', 'pageSettings.autoScrollBorder', 'pageSettings.multiplePage',
    'pageSettings.pageBackgroundColor', 'pageSettings.pageBorderColor', 'pageSettings.pageBorderWidth', 'pageSettings.pageHeight', 'pageSettings.pageMargin',
    'pageSettings.pageOrientation', 'pageSettings.pageWidth', 'pageSettings.scrollableArea', 'pageSettings.scrollLimit', 'pageSettings.boundaryConstraints',
    'pageSettings.showPageBreak', 'scrollSettings.currentZoom', 'scrollSettings.horizontalOffset', 'scrollSettings.padding', 'scrollSettings.verticalOffset',
    'scrollSettings.viewPortHeight', 'scrollSettings.viewPortWidth', 'selectedItems.children', 'selectedItems.constraints', 'selectedItems.getConstraints',
    'selectedItems.height', 'selectedItems.offsetX', 'selectedItems.offsetY', 'selectedItems.rotateAngle', 'selectedItems.tooltip',
    'selectedItems.width', 'snapSettings.enableSnapToObject', 'snapSettings.horizontalGridLines', 'snapSettings.horizontalGridLines.lineColor', 'snapSettings.horizontalGridLines.lineDashArray',
    'snapSettings.horizontalGridLines.linesInterval', 'snapSettings.horizontalGridLines.snapInterval', 'snapSettings.snapAngle', 'snapSettings.snapConstraints', 'snapSettings.snapObjectDistance',
    'snapSettings.verticalGridLines', 'snapSettings.verticalGridLines.lineColor', 'snapSettings.verticalGridLines.lineDashArray', 'snapSettings.verticalGridLines.linesInterval', 'snapSettings.verticalGridLines.snapInterval',
    'tooltip.alignment', 'tooltip.alignment.horizontal', 'tooltip.alignment.vertical', 'tooltip.margin', 'tooltip.relativeMode',
    'tooltip.templateId', 'connectors', 'nodes', 'contextMenu.items', 'nodes.class.attributes',
    'nodes.class.methods', 'nodes.enumeration.members', 'nodes.interface.attributes', 'nodes.interface.methods', 'selectedItems.userHandles'], []);
exports.DiagramComponent = core_1.CreateComponent('Diagram', {
    selector: 'ej-diagram',
    inputs: Inputs,
    outputs: Outputs,
    template: '',
    queries: {
        _commandManager_commands: new core_1.ContentChild(exports.DiagramCommandManagerCommandsDirective),
        _connectors: new core_1.ContentChild(exports.DiagramConnectorsDirective),
        _nodes: new core_1.ContentChild(exports.DiagramNodesDirective),
    }
}, {
    tags: ['commandManager.commands', 'connectors', 'nodes'],
    twoways: [],
    complexes: ComplexProperties,
});
exports.EJ_DIAGRAM_COMPONENTS = [exports.DiagramComponent, exports.DiagramCommandManagerCommandsDirective, exports.DiagramSegmentsDirective, exports.DiagramConnectorLabelsDirective, exports.DiagramConnectorsDirective, exports.DiagramNodeLabelsDirective, exports.DiagramPhasesDirective, exports.DiagramPortsDirective, exports.DiagramNodesDirective, exports.DiagramCommandManagerCommandDirective, exports.DiagramSegmentDirective, exports.DiagramConnectorLabelDirective, exports.DiagramConnectorDirective, exports.DiagramNodeLabelDirective, exports.DiagramPhaseDirective, exports.DiagramPortDirective, exports.DiagramNodeDirective];
//# sourceMappingURL=diagram.component.js.map