"use strict";
var core_1 = require("./core");
var Outputs = ['actionBegin', 'actionComplete', 'actionFailure', 'actionSuccess', 'beforePopupHide',
    'beforePopupShown', 'cascade', 'change', 'checkChange', 'create',
    'dataBound', 'destroy', 'focusIn', 'focusOut', 'popupHide',
    'popupResize', 'popupShown', 'popupResizeStart', 'popupResizeStop', 'search',
    'select',
    'model.valueChange: valueChange'];
var ComplexProperties = ['fields'];
var Inputs = core_1.Utils.AngularizeInputs(['allowVirtualScrolling', 'cascadeTo', 'caseSensitiveSearch', 'cssClass', 'dataSource',
    'delimiterChar', 'enableAnimation', 'enabled', 'enableIncrementalSearch', 'enableFilterSearch',
    'enablePersistence', 'enablePopupResize', 'enableRTL', 'enableSorting', 'fields',
    'filterType', 'headerTemplate', 'height', 'htmlAttributes', 'itemsCount',
    'locale', 'maxPopupHeight', 'minPopupHeight', 'maxPopupWidth', 'minPopupWidth',
    'multiSelectMode', 'popupHeight', 'popupWidth', 'query', 'readOnly',
    'selectedIndex', 'selectedIndices', 'showCheckbox', 'showPopupOnLoad', 'showRoundedCorner',
    'sortOrder', 'targetID', 'template', 'text', 'validationMessage',
    'validationRules', 'watermarkText', 'width', 'virtualScrollMode', 'fields.groupBy',
    'fields.htmlAttributes', 'fields.id', 'fields.imageAttributes', 'fields.imageUrl', 'fields.selected',
    'fields.spriteCssClass', 'fields.tableName', 'fields.text', 'fields.value'], ['value']);
exports.DropDownListComponent = core_1.CreateComponent('DropDownList', {
    selector: '[ej-dropdownlist]',
    inputs: Inputs,
    outputs: Outputs,
    template: '',
    queries: {}
}, {
    tags: [],
    twoways: ['value'],
    complexes: ComplexProperties,
});
exports.DropDownListValueAccessor = core_1.CreateControlValueAccessor('[ej-dropdownlist]', exports.DropDownListComponent);
exports.EJ_DROPDOWNLIST_COMPONENTS = [exports.DropDownListComponent, exports.DropDownListValueAccessor];
//# sourceMappingURL=dropdownlist.component.js.map