"use strict";
var core_1 = require("./core");
var Outputs = ['beforeAjaxRequest', 'beforeDownload', 'beforeGetImage', 'beforeOpen', 'beforeUpload',
    'create', 'copy', 'createFolder', 'cut', 'destroy',
    'dragStart', 'drag', 'dragStop', 'drop', 'getImage',
    'keydown', 'layoutChange', 'menuBeforeOpen', 'menuClick', 'menuOpen',
    'open', 'paste', 'remove', 'resize', 'resizeStart',
    'resizeStop', 'select', 'templateRefresh', 'unselect'
];
var ComplexProperties = ['contextMenuSettings', 'filterSettings', 'gridSettings', 'uploadSettings'];
var Inputs = core_1.Utils.AngularizeInputs(['ajaxAction', 'ajaxDataType', 'ajaxSettings', 'allowDragAndDrop', 'allowKeyboardNavigation',
    'allowMultiSelection', 'contextMenuSettings', 'cssClass', 'enablePersistence', 'enableResize',
    'enableRTL', 'enableThumbnailCompress', 'fileTypes', 'filterSettings', 'gridSettings',
    'height', 'isResponsive', 'layout', 'locale', 'maxHeight',
    'maxWidth', 'minHeight', 'minWidth', 'path', 'selectedFolder',
    'selectedItems', 'showCheckbox', 'showContextMenu', 'showFooter', 'showRoundedCorner',
    'showThumbnail', 'showToolbar', 'showNavigationPane', 'tools', 'toolsList',
    'uploadSettings', 'width', 'contextMenuSettings.items', 'contextMenuSettings.customMenuFields', 'filterSettings.allowSearchOnTyping',
    'filterSettings.caseSensitiveSearch', 'filterSettings.filterType', 'gridSettings.allowResizing', 'gridSettings.allowSorting', 'gridSettings.columns',
    'uploadSettings.maxFileSize', 'uploadSettings.allowMultipleFile', 'uploadSettings.autoUpload'], []);
exports.FileExplorerComponent = core_1.CreateComponent('FileExplorer', {
    selector: 'ej-fileexplorer',
    inputs: Inputs,
    outputs: Outputs,
    template: '',
    queries: {}
}, {
    tags: [],
    twoways: [],
    complexes: ComplexProperties,
});
exports.EJ_FILEEXPLORER_COMPONENTS = [exports.FileExplorerComponent];
//# sourceMappingURL=fileexplorer.component.js.map