"use strict";
var core_1 = require("./core");
var HeatMapColorMappingInputs = core_1.Utils.AngularizeInputs(['color', 'value', 'label', 'label.bold', 'label.italic',
    'label.text', 'label.textDecoration', 'label.fontSize', 'label.fontFamily', 'label.fontColor'], []);
exports.HeatMapColorMappingDirective = core_1.CreateComplexDirective({
    selector: 'e-colormappingcollection>e-colormapping',
    inputs: HeatMapColorMappingInputs,
    queries: {}
}, {
    tags: [],
    complexes: ['label'],
    type: core_1.forwardRef(function () { return exports.HeatMapComponent; })
});
exports.HeatMapColorMappingCollectionDirective = core_1.CreateArrayTagDirective('colorMappingCollection', 'ej-heatmap>e-colormappingcollection', exports.HeatMapColorMappingDirective);
var Outputs = ['cellMouseOver', 'cellMouseEnter', 'cellMouseLeave', 'cellSelected'
];
var ComplexProperties = ['tooltipSettings', 'heatMapCell', 'defaultColumnStyle', 'itemsMapping', 'tooltipSettings.position',
    'tooltipSettings.position.target', 'tooltipSettings.position.stem', 'tooltipSettings.animation', 'itemsMapping.columnStyle', 'itemsMapping.column',
    'itemsMapping.row', 'itemsMapping.value', 'itemsMapping.headerMapping'];
var Inputs = core_1.Utils.AngularizeInputs(['width', 'height', 'id', 'showTooltip', 'tooltipSettings',
    'itemsSource', 'heatMapCell', 'isResponsive', 'enableVirtualization', 'defaultColumnStyle',
    'legendCollection', 'itemsMapping', 'tooltipSettings.templateId', 'tooltipSettings.associate', 'tooltipSettings.isBalloon',
    'tooltipSettings.position', 'tooltipSettings.position.target', 'tooltipSettings.position.stem', 'tooltipSettings.trigger', 'tooltipSettings.animation',
    'tooltipSettings.animation.effect', 'tooltipSettings.animation.speed', 'heatMapCell.showContent', 'heatMapCell.showColor', 'defaultColumnStyle.textAlign',
    'defaultColumnStyle.headerTemplateID', 'defaultColumnStyle.templateID', 'itemsMapping.columnStyle', 'itemsMapping.columnStyle.width', 'itemsMapping.columnStyle.textAlign',
    'itemsMapping.columnStyle.headerTemplateID', 'itemsMapping.columnStyle.templateID', 'itemsMapping.column', 'itemsMapping.column.propertyName', 'itemsMapping.column.displayName',
    'itemsMapping.row', 'itemsMapping.row.propertyName', 'itemsMapping.row.displayName', 'itemsMapping.value', 'itemsMapping.value.propertyName',
    'itemsMapping.value.displayName', 'itemsMapping.headerMapping', 'itemsMapping.headerMapping.propertyName', 'itemsMapping.headerMapping.displayName', 'itemsMapping.headerMapping.columnStyle',
    'itemsMapping.columnMapping', 'colorMappingCollection'], []);
exports.HeatMapComponent = core_1.CreateComponent('HeatMap', {
    selector: 'ej-heatmap',
    inputs: Inputs,
    outputs: Outputs,
    template: '',
    queries: {
        _colorMappingCollection: new core_1.ContentChild(exports.HeatMapColorMappingCollectionDirective),
    }
}, {
    tags: ['colorMappingCollection'],
    twoways: [],
    complexes: ComplexProperties,
});
exports.EJ_HEATMAP_COMPONENTS = [exports.HeatMapComponent, exports.HeatMapColorMappingCollectionDirective, exports.HeatMapColorMappingDirective];
//# sourceMappingURL=heatmap.component.js.map