"use strict";
var core_1 = require("./core");
var KanbanColumnInputs = core_1.Utils.AngularizeInputs(['headerText', 'totalCount', 'totalCount.text', 'key', 'allowDrop',
    'allowDrag', 'isCollapsed', 'constraints', 'constraints.type', 'constraints.min',
    'constraints.max', 'headerTemplate', 'width', 'visible', 'showAddButton'], []);
exports.KanbanColumnDirective = core_1.CreateComplexDirective({
    selector: 'e-kanban-columns>e-kanban-column',
    inputs: KanbanColumnInputs,
    queries: {}
}, {
    tags: [],
    complexes: ['totalCount', 'constraints'],
    type: core_1.forwardRef(function () { return exports.KanbanComponent; })
});
exports.KanbanColumnsDirective = core_1.CreateArrayTagDirective('columns', 'ej-kanban>e-kanban-columns', exports.KanbanColumnDirective);
var Outputs = ['actionBegin', 'actionComplete', 'actionFailure', 'beginEdit', 'beginAdd',
    'beforeCardSelect', 'cardClick', 'cardDrag', 'cardDragStart', 'cardDragStop',
    'cardDrop', 'cardSelect', 'cardDoubleClick', 'cardSelecting', 'create',
    'cellClick', 'dataBound', 'destroy', 'endDelete', 'endEdit',
    'headerClick', 'load', 'toolbarClick', 'queryCellInfo', 'contextOpen',
    'model.dataSourceChange: dataSourceChange'];
var ComplexProperties = ['swimlaneSettings', 'contextMenuSettings', 'cardSettings', 'editSettings', 'fields',
    'scrollSettings', 'searchSettings', 'tooltipSettings', 'swimlaneSettings.unassignedGroup'];
var Inputs = core_1.Utils.AngularizeInputs(['allowDragAndDrop', 'allowTitle', 'swimlaneSettings', 'allowToggleColumn', 'allowSearching',
    'allowFiltering', 'allowSelection', 'allowHover', 'allowKeyboardNavigation', 'allowScrolling',
    'allowPrinting', 'contextMenuSettings', 'cardSettings', 'cssClass', 'enableTouch',
    'enableRTL', 'enableTotalCount', 'editSettings', 'fields', 'keyField',
    'isResponsive', 'minWidth', 'query', 'keySettings', 'scrollSettings',
    'searchSettings', 'selectionType', 'tooltipSettings', 'locale', 'swimlaneSettings.showCount',
    'swimlaneSettings.allowDragAndDrop', 'swimlaneSettings.unassignedGroup', 'swimlaneSettings.unassignedGroup.enable', 'swimlaneSettings.unassignedGroup.keys', 'contextMenuSettings.enable',
    'contextMenuSettings.disableDefaultItems', 'contextMenuSettings.menuItems', 'cardSettings.template', 'cardSettings.colorMapping', 'editSettings.allowEditing',
    'editSettings.allowAdding', 'editSettings.dialogTemplate', 'editSettings.editMode', 'editSettings.externalFormTemplate', 'editSettings.formPosition',
    'fields.primaryKey', 'fields.swimlaneKey', 'fields.priority', 'fields.content', 'fields.tag',
    'fields.title', 'fields.color', 'fields.imageUrl', 'scrollSettings.height', 'scrollSettings.width',
    'scrollSettings.allowFreezeSwimlane', 'searchSettings.fields', 'searchSettings.key', 'searchSettings.operator', 'searchSettings.ignoreCase',
    'tooltipSettings.enable', 'tooltipSettings.template', 'columns', 'customToolbarItems', 'filterSettings',
    'stackedHeaderRows', 'workflows', 'contextMenuSettings.customMenuItems', 'editSettings.editItems'], ['dataSource']);
exports.KanbanComponent = core_1.CreateComponent('Kanban', {
    selector: 'ej-kanban',
    inputs: Inputs,
    outputs: Outputs,
    template: '',
    queries: {
        _columns: new core_1.ContentChild(exports.KanbanColumnsDirective),
    }
}, {
    tags: ['columns'],
    twoways: ['dataSource'],
    complexes: ComplexProperties,
});
exports.EJ_KANBAN_COMPONENTS = [exports.KanbanComponent, exports.KanbanColumnsDirective, exports.KanbanColumnDirective];
//# sourceMappingURL=kanban.component.js.map