"use strict";
var core_1 = require("./core");
var LinearGaugeMarkerPointerInputs = core_1.Utils.AngularizeInputs(['backgroundColor', 'border', 'border.color', 'border.width', 'distanceFromScale',
    'gradients', 'length', 'opacity', 'placement', 'type',
    'value', 'width'], []);
exports.LinearGaugeMarkerPointerDirective = core_1.CreateComplexDirective({
    selector: 'e-markerpointers>e-markerpointer',
    inputs: LinearGaugeMarkerPointerInputs,
    queries: {}
}, {
    tags: [],
    complexes: ['border'],
    type: core_1.forwardRef(function () { return exports.LinearGaugeComponent; })
});
exports.LinearGaugeMarkerPointersDirective = core_1.CreateArrayTagDirective('markerPointers', 'e-scales>e-markerpointers', exports.LinearGaugeMarkerPointerDirective);
var LinearGaugeBarPointerInputs = core_1.Utils.AngularizeInputs(['backgroundColor', 'border', 'border.color', 'border.width', 'distanceFromScale',
    'gradients', 'opacity', 'value', 'width'], []);
exports.LinearGaugeBarPointerDirective = core_1.CreateComplexDirective({
    selector: 'e-barpointers>e-barpointer',
    inputs: LinearGaugeBarPointerInputs,
    queries: {}
}, {
    tags: [],
    complexes: ['border'],
    type: core_1.forwardRef(function () { return exports.LinearGaugeComponent; })
});
exports.LinearGaugeBarPointersDirective = core_1.CreateArrayTagDirective('barPointers', 'e-scales>e-barpointers', exports.LinearGaugeBarPointerDirective);
var LinearGaugeRangeInputs = core_1.Utils.AngularizeInputs(['backgroundColor', 'border', 'border.color', 'border.width', 'distanceFromScale',
    'endValue', 'endWidth', 'gradients', 'opacity', 'placement',
    'startValue', 'startWidth'], []);
exports.LinearGaugeRangeDirective = core_1.CreateComplexDirective({
    selector: 'e-ranges>e-range',
    inputs: LinearGaugeRangeInputs,
    queries: {}
}, {
    tags: [],
    complexes: ['border'],
    type: core_1.forwardRef(function () { return exports.LinearGaugeComponent; })
});
exports.LinearGaugeRangesDirective = core_1.CreateArrayTagDirective('ranges', 'e-scales>e-ranges', exports.LinearGaugeRangeDirective);
var LinearGaugeTickInputs = core_1.Utils.AngularizeInputs(['angle', 'color', 'distanceFromScale', 'distanceFromScale.x', 'distanceFromScale.y',
    'height', 'opacity', 'placement', 'type', 'width'], []);
exports.LinearGaugeTickDirective = core_1.CreateComplexDirective({
    selector: 'e-ticks>e-tick',
    inputs: LinearGaugeTickInputs,
    queries: {}
}, {
    tags: [],
    complexes: ['distanceFromScale'],
    type: core_1.forwardRef(function () { return exports.LinearGaugeComponent; })
});
exports.LinearGaugeTicksDirective = core_1.CreateArrayTagDirective('ticks', 'e-scales>e-ticks', exports.LinearGaugeTickDirective);
var LinearGaugeStateRangeInputs = core_1.Utils.AngularizeInputs(['backgroundColor', 'borderColor', 'endValue', 'startValue', 'text',
    'textColor'], []);
exports.LinearGaugeStateRangeDirective = core_1.CreateComplexDirective({
    selector: 'e-stateranges>e-staterange',
    inputs: LinearGaugeStateRangeInputs,
    queries: {}
}, {
    tags: [],
    complexes: [],
    type: core_1.forwardRef(function () { return exports.LinearGaugeComponent; })
});
exports.LinearGaugeStateRangesDirective = core_1.CreateArrayTagDirective('stateRanges', 'e-indicators>e-stateranges', exports.LinearGaugeStateRangeDirective);
var LinearGaugeIndicatorInputs = core_1.Utils.AngularizeInputs(['backgroundColor', 'border', 'border.color', 'border.width', 'font',
    'font.fontFamily', 'font.fontStyle', 'font.size', 'height', 'opacity',
    'position', 'position.x', 'position.y', 'stateRanges', 'textLocation',
    'textLocation.x', 'textLocation.y', 'type', 'width'], []);
exports.LinearGaugeIndicatorDirective = core_1.CreateComplexDirective({
    selector: 'e-indicators>e-indicator',
    inputs: LinearGaugeIndicatorInputs,
    queries: {
        _stateRanges: new core_1.ContentChild(exports.LinearGaugeStateRangesDirective),
    }
}, {
    tags: ['stateRanges'],
    complexes: ['border', 'font', 'position', 'textLocation'],
    type: core_1.forwardRef(function () { return exports.LinearGaugeComponent; })
});
exports.LinearGaugeIndicatorsDirective = core_1.CreateArrayTagDirective('indicators', 'e-scales>e-indicators', exports.LinearGaugeIndicatorDirective);
var LinearGaugeLabelInputs = core_1.Utils.AngularizeInputs(['angle', 'distanceFromScale', 'distanceFromScale.x', 'distanceFromScale.y', 'font',
    'font.fontFamily', 'font.fontStyle', 'font.size', 'includeFirstValue', 'opacity',
    'placement', 'textColor', 'type', 'unitText', 'unitTextPlacement'], []);
exports.LinearGaugeLabelDirective = core_1.CreateComplexDirective({
    selector: 'e-labels>e-label',
    inputs: LinearGaugeLabelInputs,
    queries: {}
}, {
    tags: [],
    complexes: ['distanceFromScale', 'font'],
    type: core_1.forwardRef(function () { return exports.LinearGaugeComponent; })
});
exports.LinearGaugeLabelsDirective = core_1.CreateArrayTagDirective('labels', 'e-scales>e-labels', exports.LinearGaugeLabelDirective);
var LinearGaugeScaleInputs = core_1.Utils.AngularizeInputs(['backgroundColor', 'barPointers', 'border', 'border.color', 'border.width',
    'customLabels', 'direction', 'indicators', 'labels', 'length',
    'majorIntervalValue', 'markerPointers', 'maximum', 'minimum', 'minorIntervalValue',
    'opacity', 'position', 'position.x', 'position.y', 'ranges',
    'shadowOffset', 'showBarPointers', 'showCustomLabels', 'showIndicators', 'showLabels',
    'showMarkerPointers', 'showRanges', 'showTicks', 'ticks', 'type',
    'width'], []);
exports.LinearGaugeScaleDirective = core_1.CreateComplexDirective({
    selector: 'e-scales>e-scale',
    inputs: LinearGaugeScaleInputs,
    queries: {
        _markerPointers: new core_1.ContentChild(exports.LinearGaugeMarkerPointersDirective),
        _barPointers: new core_1.ContentChild(exports.LinearGaugeBarPointersDirective),
        _ranges: new core_1.ContentChild(exports.LinearGaugeRangesDirective),
        _ticks: new core_1.ContentChild(exports.LinearGaugeTicksDirective),
        _indicators: new core_1.ContentChild(exports.LinearGaugeIndicatorsDirective),
        _labels: new core_1.ContentChild(exports.LinearGaugeLabelsDirective),
    }
}, {
    tags: ['markerPointers', 'barPointers', 'ranges', 'ticks', 'indicators', 'labels'],
    complexes: ['border', 'position'],
    type: core_1.forwardRef(function () { return exports.LinearGaugeComponent; })
});
exports.LinearGaugeScalesDirective = core_1.CreateArrayTagDirective('scales', 'ej-lineargauge>e-scales', exports.LinearGaugeScaleDirective);
var Outputs = ['drawBarPointers', 'drawCustomLabel', 'drawIndicators', 'drawLabels', 'drawMarkerPointers',
    'drawRange', 'drawTicks', 'init', 'load', 'mouseClick',
    'mouseClickMove', 'mouseClickUp', 'renderComplete',
    'model.valueChange: valueChange', 'model.minimumChange: minimumChange', 'model.maximumChange: maximumChange'];
var ComplexProperties = ['frame', 'tooltip'];
var Inputs = core_1.Utils.AngularizeInputs(['animationSpeed', 'backgroundColor', 'borderColor', 'enableAnimation', 'enableMarkerPointerAnimation',
    'isResponsive', 'frame', 'height', 'labelColor', 'orientation',
    'outerCustomLabelPosition', 'pointerGradient1', 'pointerGradient2', 'readOnly', 'theme',
    'tickColor', 'tooltip', 'width', 'frame.backgroundImageUrl', 'frame.innerWidth',
    'frame.outerWidth', 'tooltip.showCustomLabelTooltip', 'tooltip.showLabelTooltip', 'tooltip.templateID', 'scales',
    'scales.indicators.stateRanges'], ['value', 'minimum', 'maximum']);
exports.LinearGaugeComponent = core_1.CreateComponent('LinearGauge', {
    selector: 'ej-lineargauge',
    inputs: Inputs,
    outputs: Outputs,
    template: '',
    queries: {
        _scales: new core_1.ContentChild(exports.LinearGaugeScalesDirective),
    }
}, {
    tags: ['scales'],
    twoways: ['value', 'minimum', 'maximum'],
    complexes: ComplexProperties,
});
exports.EJ_LINEARGAUGE_COMPONENTS = [exports.LinearGaugeComponent, exports.LinearGaugeMarkerPointersDirective, exports.LinearGaugeBarPointersDirective, exports.LinearGaugeRangesDirective, exports.LinearGaugeTicksDirective, exports.LinearGaugeStateRangesDirective, exports.LinearGaugeIndicatorsDirective, exports.LinearGaugeLabelsDirective, exports.LinearGaugeScalesDirective, exports.LinearGaugeMarkerPointerDirective, exports.LinearGaugeBarPointerDirective, exports.LinearGaugeRangeDirective, exports.LinearGaugeTickDirective, exports.LinearGaugeStateRangeDirective, exports.LinearGaugeIndicatorDirective, exports.LinearGaugeLabelDirective, exports.LinearGaugeScaleDirective];
//# sourceMappingURL=lineargauge.component.js.map