"use strict";
var core_1 = require("./core");
var Outputs = ['actionBegin', 'actionSuccess', 'actionComplete', 'actionFailure', 'actionBeforeSuccess',
    'change', 'checkChange', 'create', 'destroy', 'focusIn',
    'focusOut', 'itemDrag', 'itemDragStart', 'itemDragStop', 'itemDrop',
    'select', 'unselect',
    'model.valueChange: valueChange'];
var ComplexProperties = ['fields'];
var Inputs = core_1.Utils.AngularizeInputs(['allowDrag', 'allowDrop', 'allowMultiSelection', 'allowVirtualScrolling', 'caseSensitiveSearch',
    'cascadeTo', 'checkedIndices', 'cssClass', 'dataSource', 'enabled',
    'enableIncrementalSearch', 'enablePersistence', 'enableRTL', 'enableWordWrap', 'fields',
    'height', 'itemHeight', 'itemsCount', 'totalItemsCount', 'itemRequestCount',
    'loadDataOnInit', 'query', 'selectedIndex', 'selectedIndices', 'showCheckbox',
    'showRoundedCorner', 'template', 'virtualScrollMode', 'width', 'targetID',
    'fields.checkBy', 'fields.groupBy', 'fields.htmlAttributes', 'fields.id', 'fields.imageUrl',
    'fields.imageAttributes', 'fields.selectBy', 'fields.spriteCssClass', 'fields.tableName', 'fields.text',
    'fields.value'], ['value']);
exports.ListBoxComponent = core_1.CreateComponent('ListBox', {
    selector: 'ej-listbox',
    inputs: Inputs,
    outputs: Outputs,
    template: '<ng-content></ng-content>',
    queries: {}
}, {
    tags: [],
    twoways: ['value'],
    complexes: ComplexProperties,
});
exports.EJ_LISTBOX_COMPONENTS = [exports.ListBoxComponent];
//# sourceMappingURL=listbox.component.js.map