"use strict";
var core_1 = require("./core");
var Outputs = ['beforeAdd', 'beforeCollapse', 'beforeCut', 'beforeDelete', 'beforeEdit',
    'beforeExpand', 'beforeLoad', 'beforePaste', 'beforeSelect', 'create',
    'destroy', 'inlineEditValidation', 'keyPress', 'loadError', 'loadSuccess',
    'nodeAdd', 'nodeCheck', 'nodeClick', 'nodeCollapse', 'nodeCut',
    'nodeDelete', 'nodeDrag', 'nodeDragStart', 'nodeDragStop', 'nodeDropped',
    'nodeEdit', 'nodeExpand', 'nodePaste', 'nodeSelect', 'nodeUncheck',
    'nodeUnselect', 'ready'
];
var ComplexProperties = ['fields', 'sortSettings'];
var Inputs = core_1.Utils.AngularizeInputs(['allowDragAndDrop', 'allowDragAndDropAcrossControl', 'allowDropSibling', 'allowDropChild', 'allowEditing',
    'allowKeyboardNavigation', 'allowMultiSelection', 'autoCheck', 'autoCheckParentNode', 'checkedNodes',
    'cssClass', 'enableAnimation', 'enabled', 'enableMultipleExpand', 'enablePersistence',
    'enableRTL', 'expandedNodes', 'expandOn', 'fields', 'fullRowSelect',
    'height', 'htmlAttributes', 'loadOnDemand', 'selectedNode', 'selectedNodes',
    'showCheckbox', 'sortSettings', 'template', 'width', 'fields.child',
    'fields.dataSource', 'fields.expanded', 'fields.hasChild', 'fields.htmlAttribute', 'fields.id',
    'fields.imageAttribute', 'fields.imageUrl', 'fields.isChecked', 'fields.linkAttribute', 'fields.parentId',
    'fields.query', 'fields.selected', 'fields.spriteCssClass', 'fields.tableName', 'fields.text',
    'sortSettings.allowSorting', 'sortSettings.sortOrder'], []);
exports.TreeViewComponent = core_1.CreateComponent('TreeView', {
    selector: 'ej-treeview',
    inputs: Inputs,
    outputs: Outputs,
    template: '<ng-content></ng-content>',
    queries: {}
}, {
    tags: [],
    twoways: [],
    complexes: ComplexProperties,
});
exports.EJ_TREEVIEW_COMPONENTS = [exports.TreeViewComponent];
//# sourceMappingURL=treeview.component.js.map